/***************************************************************************
                          caliaslist.h  -  alias list
    This file is a part of KMuddy distribution.
                             -------------------
    begin                : Ct sep 12 2002
    copyright            : (C) 2002 by Tomas Mecir
    email                : kmuddy@kmuddy.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CALIASLIST_H
#define CALIASLIST_H

#include "csaveablelist.h"

/**
A list of aliases.
Includes functions that do alias matching and similar stuff
(it's mostly inherited from cSaveableList).
  *@author Tomas Mecir
  */

class cAliasList : public cSaveableList {
  Q_OBJECT
public: 
  cAliasList (QString filename, int sess);
  ~cAliasList ();
  virtual void newString ();
  virtual void processCommands (const QStringList &commands);

  /** Perform matching of string against items of the list. Each match produces command(s),
  which are passed to processCommands() */
  virtual void matchString (const QString &string);
  
  const QStringList &getMatchedCommands () { return matchedcommands; };
  bool wasMatch () { return wasmatch; };
protected:
  bool wasmatch;
  QStringList matchedcommands;
  
  cExpResolver *resolver;
};

#endif
