/***************************************************************************
                          cconnectioninfo.h  -  info about connection
    This file is a part of KMuddy distribution.
                             -------------------
    begin                : Po Jul 22 2002
    copyright            : (C) 2002 by Tomas Mecir
    email                : kmuddy@kmuddy.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CCONNECTIONINFO_H
#define CCONNECTIONINFO_H

#include <qstringlist.h>

/**
Information about one connection - server, port etc.
Used when creating both normal and quick connection
This doubles some information from cConnPrefs, as this object is not
created for QuickConnect (this also means that aliases, macros, triggers and
similar things are not available in QuickConnect mode)
  *@author Tomas Mecir
  */

class cConnectionInfo {
  QString _name, _server;
  QString _login, _password;
  int _port;
  QStringList _connstr;
  bool _isquick;
    
public: 
  cConnectionInfo ();
  ~cConnectionInfo ();

  void setName (const QString &s) { _name = s; };
  const QString name () { return _name; };
  void setServer (const QString &s) { _server = s; };
  const QString server () { return _server; };
  void setLogin (const QString &s) { _login = s; };
  const QString login () { return _login; };
  void setPassword (const QString &s) { _password = s; };
  const QString password () { return _password; };
  void setPort (int port);
  int port () { return _port; };
  void setConnStr (QStringList str) { _connstr = str; };
  QStringList connStr () { return _connstr; };
  void setIsQuick (bool quick) { _isquick = quick; };
  bool isQuick () { return _isquick; };
};

#endif
