/***************************************************************************
                          cgroup.h  -  alias/trigger group
                             -------------------
    begin                : Ct dec 5 2002
    copyright            : (C) 2002 by Tomas Mecir
    email                : kmuddy@kmuddy.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CGROUP_H
#define CGROUP_H

#include "csaveablefield.h"

/**
This is one alias/trigger group. All it can do is to activate/deactivate itself (and to load/save itself, of course).

  *@author Tomas Mecir
  */

class cGroup : public cSaveableField  {
   Q_OBJECT
public: 
  cGroup ();
  ~cGroup ();

  /** creates a new instance of the class */
  virtual cSaveableField *newInstance ();

  /** load data from a config file */
  virtual void load (KConfig *config, const QString &group);
  /** save data to a config file */
  virtual void save (KConfig *config, const QString &group);

  /** activate/deactivate this group */
  void setActive (bool what) { activated = what; };
  /** is this group active? */
  bool active () { return activated; };

  /** set group number */
  void setNumber (int number) { _number = number; };
  /** returns group number */
  int number () { return _number; };
  
  //group name is stored in the "text" attribute inherited from cSaveableList
  //and accessible vie getText() and setText() methods
  
  /** returns type of item (light-weight RTTI) */
  virtual int itemType () { return TYPE_GROUP; };

  /** NOT NEEDED HERE */
  virtual bool match (const QString &) { return false; };
  /** NOT NEEDED HERE */
  virtual QString performAction () { return QString::null; };

  /** NOT NEEDED HERE */
  virtual bool shouldContinue (bool) { return false; };
protected:
  bool activated;
  int _number;
};

#endif
