/***************************************************************************
                          cgrouplist.h  -  description
                             -------------------
    begin                : St dec 5 2002
    copyright            : (C) 2002 by Tomas Mecir
    email                : kmuddy@kmuddy.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CGROUPLIST_H
#define CGROUPLIST_H

#include "csaveablelist.h"

class dlgGroups;

/**
A list of alias/trigger groups.
  *@author Tomas Mecir
  */

class cGroupList : public cSaveableList  {
   Q_OBJECT
public: 
  cGroupList (QString filename, QString listName, int sess, cSaveableList *assignedList);
  ~cGroupList ();

  /** update items in assigned list - called when we delete some group
  and on startup */
  void updateAssignedList ();
  
  /** some functions that modify the list in a "safe" way */

  /** the functions that manipulate the list directly have to remain
  public :(( protected inheritence behaves VERY strangely - functions from
  cSaveableLst don't have access to other functions from the same class (!!!)*/
  /** enable/disable certain group */
  void activateGroup (int id, bool active);
  /** creates a group and returns its ID */
  int addGroup (const QString &name);
  /** removes a group, unless it's the BASE group, returns true if successful */
  bool removeGroup (int id);
  /** renames a group, unless it's the BASE group, returns true if successful */
  bool renameGroup (int id, const QString &newname);
  
  void setDialog (dlgGroups *dlg) { dlggroups = dlg; };
  dlgGroups *dialog () { return dlggroups; };
  
  /** return groupid from name, -1 if not real **/
  int getGroupId (const QString &name);

/** NOT NEEDED HERE */
  virtual void processCommands (const QStringList &) {};
  
protected:
  /** assigned list that uses our groups */
  cSaveableList *list;

  /** function that returns a group with requested ID */
  cGroup *getGroup (int id);
  
  dlgGroups *dlggroups;
};

#endif
